<?php

class ARF_pdfcreator_template
{

    public $font_family;

    function __construct( $font_family )
    {
        $this->font_family = $font_family;
    }

    function get_arf_pdf_templates()
    {

        $templates = array();

        $template_dir_path = ARF_PDFCREATOR_DIR . '/core/templates/';

        $templates_list = glob($template_dir_path . '*.*');

        if (count($templates_list) > 0 ) {

            foreach ( $templates_list as $file ) {

                $file_key = str_replace($template_dir_path, '', $file);

                $file_value = str_replace('.php', '', $file_key);

                $file_value = str_replace('_', ' ', $file_value);

                $templates[ $file_key ] = $file_value;

            }
        }

        return $templates;
    }

    function get_arfpdf_template( $form_id )
    {

        global $wpdb,$MdlDb;

        if (! isset($GLOBALS['arf_form_pdfcreator_form_options'][ $form_id ]) ) {

            $frm_opt = $wpdb->get_results($wpdb->prepare('SELECT options FROM ' . $MdlDb->forms . ' WHERE id = %d', $form_id));

            $options = maybe_unserialize($frm_opt[0]->options);

            $GLOBALS['arf_form_pdfcreator_form_options'][ $form_id ] = $options;

        } else {

            $options = $GLOBALS['arf_form_pdfcreator_form_options'][ $form_id ];

        }

        return isset($options['arf_pdf_template']) ? $options['arf_pdf_template'] : '';

    }

    function arf_get_template_html( $templatename, $arf_pdfcreator, $form_id, $entry_id )
    {
        global $wpdb, $arfrecordmeta, $arformspdfcreator,$MdlDb,$arfieldhelper,$db_record, $arformcontroller;

        $form = $wpdb->get_row($wpdb->prepare('SELECT form_id,created_date FROM ' . $MdlDb->entries . ' WHERE id = %d', $entry_id));

        $created_date = strtotime($form->created_date);

        $form_details = $wpdb->get_row($wpdb->prepare('SELECT options,name FROM ' . $MdlDb->forms . ' WHERE id = %d', $form_id));

        $form_name = stripslashes_deep(strip_tags($form_details->name));

        $form_options = maybe_unserialize($form_details->options);

        $entry_ids = array( $entry_id );

        $get_form_fields = $wpdb->get_results($wpdb->prepare('SELECT id, name, type, field_options,conditional_logic FROM ' . $MdlDb->fields . " WHERE form_id = %d and type not in ('captcha', 'break', 'imagecontrol') ORDER BY id", $form_id));

        $values = array();
        $cntr   = 1;

        $field_order   = json_decode($form_options['arf_field_order'], true);
        $inner_field_order = json_decode( $form_options['arf_inner_field_order'], true );
        $new_form_cols = array();

        asort($field_order);

        $hidden_fields    = array();
        $hidden_field_ids = array();

        $item_meta_values = array();

        foreach ( $get_form_fields as $field ) {

            $field->field_options = json_decode($field->field_options);

            $field_values = $wpdb->get_row($wpdb->prepare('SELECT entry_value FROM ' . $MdlDb->entry_metas . ' WHERE field_id = %d and entry_id = %d', $field->id, $entry_id));

            $item_meta_values[ $field->id ] = ( $field->type == 'checkbox' ) ? maybe_unserialize($field_values->entry_value) : $field_values->entry_value;
            if ($field->type == 'checkbox' && ! is_array($item_meta_values[ $field->id ]) ) {
                $item_meta_values[ $field->id ] = (array) $item_meta_values[ $field->id ];
            }
        }



        $conditional_logic = $form_options['arf_conditional_logic_rules'];
        $tempfields        = array();

        $fields = $arfieldhelper->get_form_fields_tmp(false, $form_id, false, 0);
        
        $arf_sorted_fields = array();

        if ($field_order != '') {
            foreach ($field_order as $field_id => $order) {
                if(is_int($field_id)){
                    foreach ($fields as $field) {
                        if ($field_id == $field->id) {
                            $arf_sorted_fields[] = $field;
                            if( $field->type == 'section' ){
                                $in_field_order = $inner_field_order[$field->id];
                                $temp_field_order = array();
                                foreach( $in_field_order as $k => $order_val ){
                                    $exploded_data = explode( '|', $order_val );
                                    $temp_field_order[$exploded_data[0]] = $exploded_data[1];
                                }
                                asort( $temp_field_order );
                                foreach( $temp_field_order as $inner_field_id => $inner_order ){
                                    $field_key = $arformcontroller->arfSearchArray($inner_field_id,'id', $arformcontroller->arfObjtoArray($fields));
                                    if( '' !== $field_key ){
                                        $arf_sorted_fields[] = $fields[$field_key];
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        $fields = $arf_sorted_fields;

        $item_meta_values = apply_filters('arf_trim_values', $item_meta_values);

        foreach ( $get_form_fields as $field ) {

            $field_conditional_logic = maybe_unserialize($field->conditional_logic);
            $running_total           = isset($field->field_options->enable_total) ? $field->field_options->enable_total : 0;
            if ($field_conditional_logic == '1' ) {

                $tempfields = $arfieldhelper->post_validation_filed_display($field, $fields, $item_meta_values, $conditional_logic);

            }
            if ($field->type == 'html' && $running_total == 0 ) {
                if (isset($field_order[ $field->id ]) ) {
                    unset($field_order[ $field->id ]);
                }
            }
        }

        $removed_field_ids = array();

        foreach ( $tempfields as $k => $fid ) {

            if (isset($field_order[ $fid ]) ) {

                array_push($removed_field_ids, $fid);

                unset($field_order[ $fid ]);
            }
        }

        $tmpbreaks = array();

        $tmpdivider = array();

        $allfieldsarr = array();

        $allfieldstype = array();

        foreach ( $fields as $key => $postfield ) {

            $allfieldsarr[] = $postfield->id;

            $allfieldstype[] = $postfield->type;

            if (is_array($tempfields) and ! empty($tempfields) and in_array($postfield->id, $tempfields) ) {

                if ( $postfield->type == 'break') {
                    $tmpbreaks[] = $key;
                }
                if( $postfield->type == 'divider' ){
                    $tmpdivider[] = $key;
                }
            }
        }
        $fieldsarray = array();

        foreach( $tmpbreaks as $key => $value ){
            $first = $tmpbreaks[$key];
            $last = isset($tmpbreaks[$key + 1]) ? $tmpbreaks[$key + 1] : count($allfieldsarr) - 1;
            for( $pg = $first; $pg < $last; $pg++ ){
                if( isset($allfieldstype[$pg + 1]) && $allfieldstype[$pg + 1] == 'break' && !in_array($allfieldsarr[$pg + 1], $tempfields) ){
                    $last = $pg + 1;
                }
            }

            for( $x1 = $first; $x1 <= $last; $x1++ ){
                $fieldsarray[] = isset($allfieldsarr[$x1]) ? $allfieldsarr[$x1] : '';
            }
        }

        /* Remove Fields from Hidden Section */
        foreach( $tmpdivider as $key => $value ){
            $first = $tmpdivider[$key];
            $last = isset($tmpdivider[$key + 1]) ? $tmpdivider[$key + 1] : count($allfieldsarr) - 1;
            for( $pd = $first; $pd < $last; $pd++ ){
                if( isset($allfieldstype[$pd + 1]) && ($allfieldstype[$pd + 1] == 'break' || $allfieldstype[$pd + 1] == 'divider') && !in_array($allfieldsarr[$pd + 1], $tempfields) ){
                    $last = $pd + 1;
                }
            }

            for( $x2 = $first; $x2 <= $last; $x2++ ){
                $fieldsarray[] = isset($allfieldsarr[$x2]) ? $allfieldsarr[$x2] : '';
            }
        }
        foreach ( $field_order as $tmp_fid => $value ) {

            if (in_array($tmp_fid, $fieldsarray) ) {

                unset($field_order[ $tmp_fid ]);
            }
        }
        foreach ( $field_order as $field_id => $order ) {
            if (is_int($field_id) ) {
                foreach ( $get_form_fields as $field ) {
                    if ($field_id == $field->id ) {
                        $new_form_cols[] = $field;
                        if( $field->type == 'section' ){
                            $in_field_order = $inner_field_order[$field->id];
                            $temp_field_order = array();
                            foreach( $in_field_order as $k => $order_val ){
                                $exploded_data = explode( '|', $order_val );
                                $temp_field_order[$exploded_data[0]] = $exploded_data[1];
                            }
                            asort( $temp_field_order );
                            foreach( $temp_field_order as $inner_field_id => $inner_order ){
                                $field_key = $arformcontroller->arfSearchArray($inner_field_id,'id', $arformcontroller->arfObjtoArray($fields));
                                if( '' !== $field_key ){
                                    $new_form_cols[] = $fields[$field_key];
                                }
                            }
                        }
                    } elseif ($field->type == 'hidden' ) {
                        if (! in_array($field->id, $hidden_field_ids) ) {
                            $hidden_fields[]    = $field;
                            $hidden_field_ids[] = $field->id;
                        }
                    }
                }
            }
        }
        if (count($hidden_fields) > 0 ) {
            $new_form_cols = array_merge($new_form_cols, $hidden_fields);
        }
        $get_form_fields = $new_form_cols;

        foreach ( $get_form_fields as $field ) {
            if( is_array( $field->field_options ) ){
                $field->field_options = json_encode( $field->field_options );
            }
            $field->field_options = ( ! is_object($field->field_options) ) ? json_decode($field->field_options) : '';

            $field_values = $wpdb->get_row($wpdb->prepare('SELECT entry_value FROM ' . $MdlDb->entry_metas . ' WHERE field_id = %d and entry_id = %d', $field->id, $entry_id));

            $values[ $cntr ] = (object) array_merge((array) $field, (array) $field_values);
            $cntr++;

        }

        if( 'string' == gettype( $templatename) && ! preg_match('/^[\d+]+$/', $templatename, $match) ){
            $templatename = 1;
        }
        
        $template_data = $wpdb->get_row($wpdb->prepare('SELECT * FROM ' . $arformspdfcreator->db_pdf_creator . ' WHERE id=%d', $templatename));

        $content = stripcslashes($template_data->template_content);

        $template_header = maybe_unserialize($template_data->template_header);

        $template_footer = maybe_unserialize($template_data->template_footer);

        $template_setting = maybe_unserialize($template_data->template_settings);

        $template_header_img = maybe_unserialize($template_data->template_header_img);

        if (! empty($template_header) ) {
            foreach ( $template_header as $key => $value ) {

                if ($key == $template_header_img['pdf_header_img_align'] && $template_header_img['pdf_header_img_name'] != '' ) {
                    $path                    = site_url() . '/wp-content/uploads/arforms/' . $template_header_img['pdf_header_img_name'];
                    $template_header[ $key ] = '<img src="' . $path . '" height="50" width="50" />';
                } else {
                    $template_header[ $key ] = $arformspdfcreator->ARFPDF_Convert_Shortcode_values($values, $value, $entry_id);
                }
            }
        }

        if (! empty($template_footer) ) {
            foreach ( $template_footer as $key => $value ) {
                if ($template_setting['arf_pdf_pgno'] == 1 && $key == 'right' ) {
                    $template_footer[ $key ] = '{PAGENO} / {nb}';
                } else {
                    $template_footer[ $key ] = $arformspdfcreator->ARFPDF_Convert_Shortcode_values($values, $value, $entry_id);
                }
            }
        }

        $header_content = $arformspdfcreator->arf_pdf_get_template_header($template_header, $this->font_family);

        $footer_content = $arformspdfcreator->arf_pdf_get_template_footer($form, $template_footer, $this->font_family);

        $content = $arformspdfcreator->ARFPDF_Convert_Shortcode_values($values, $content, $entry_id);
        return $content;
    }
}


