<?php
    
if(version_compare($newarformspdfcreator_version, '2.0', '<') ) {

    global $wpdb,$arformspdfcreator,$MdlDb;

    if(file_exists(ABSPATH . 'wp-admin/includes/upgrade.php')) {
            include_once ABSPATH . 'wp-admin/includes/upgrade.php';
    }

    $table_name = $wpdb->prefix . 'arf_pdf_creator';

    $sql = "CREATE TABLE IF NOT EXISTS {$table_name} (
				id int(11) NOT NULL auto_increment,		
				template_name varchar(100) NOT NULL,
				template_content text NOT NULL,
				template_header text NOT NULL,
				template_footer text NOT NULL,
				template_settings text NOT NULL,
				template_header_img text NOT NULL,
				created_at datetime NOT NULL,
				PRIMARY KEY (id)
			  ) {$charset_collate};";

       dbDelta($sql);

       $template_dir = ARF_PDFCREATOR_DIR.'/core/templates';

       $pdf_templates = scandir($template_dir);

       $signature_remove_pattern = '/(\[ARF_Signature\](.*?)\[\/ARF_Signature\])/';

    $pattern_val_in_cond = "/\[ARF_GetValue\:(.*?)\]/";
    $pattern_lab_in_cond = "/\[ARF_GetLabel\:(.*?)\]/";

    $file_name_arr = array();

    foreach( $pdf_templates as $templates ){
        if($templates == '.' || $templates == '..' ) {
            continue;
        }
        $file_content = file_get_contents($template_dir.'/'.$templates);

        $temp_name = explode('.', $templates);
        if(count($temp_name) > 2 ) {
            $template_name = "";
            for($i = 0; $i < count($temp_name) - 1; $i++ ){
                $template_name .= $temp_name[$i].'.';
            }
            $template_name = rtrim($template_name, '.');
        } else {
            $template_name = $temp_name[0];
        }
        $template_name = str_replace('_', ' ', $template_name);

        $content = $file_content;

        preg_match($signature_remove_pattern, $content, $matches);

        $content = isset($matches[0]) ? str_replace($matches[0], '', $content) : $content;

        $content = str_replace("{ARF_IF", "[ARF_IF", $content);
        $content = str_replace("{/ARF_IF}", "[/ARF_IF]", $content);
        $content = preg_replace("/(ARF_IF|ARF_GetLabel|ARF_GetValue|ARF_LOOP)(.*?)\}/", "$1$2]", $content);

        preg_match_all($pattern_val_in_cond, $content, $mat);

        $content = preg_replace($pattern_val_in_cond, '{ARF_GetValue:$1}', $content);
        $content = preg_replace($pattern_lab_in_cond, '{ARF_GetLabel:$1}', $content);

        $content = preg_replace("/\[VAR (.*?)\]/", "{VAR $1}", $content);

        $content = str_replace("[ARF_GetEntryID]", "{ARF_GetEntryID}", $content);

        $template_array = array();
        $template_header = array(
        'left' => '',
        'center' => '{ARF_FormTitle}',
        'right' => ''
        );
        $template_footer = array(
        'left' => '',
        'center' => '',
        'right' => ''
        );
        $template_settings = array(
        'arf_pdf_template_size' => 'A4',
        'arf_pdf_template_orientation' => 'portrait',
        'arf_pdf_template_font' => 'Arial',
        'arf_pdf_pgno' => 1
        );
        $template_header_img = array(
        'pdf_header_img_name' => '',
        'pdf_header_img_align' => 'center'
        );

        $content = str_replace("<?php echo ARF_PDFCREATOR_URL.'/css/arformspdfcreator.css';?>", ARF_PDFCREATOR_URL.'/css/arformspdfcreator.css', $content);
        $content = str_replace('<?php echo ARF_PDFCREATOR_URL."/css/arformspdfcreator.css";?>', ARF_PDFCREATOR_URL.'/css/arformspdfcreator.css', $content);

        $template_array['template_name'] = $template_name;
        $template_array['template_header'] = maybe_serialize($template_header);
        $template_array['template_footer'] = maybe_serialize($template_footer);
        $template_array['template_settings'] = maybe_serialize($template_settings);
        $template_array['template_header_img'] = maybe_serialize($template_header_img);
        $template_array['template_content'] = $content;
        $template_array['created_at'] = current_time('mysql');

        $wpdb->insert($arformspdfcreator->db_pdf_creator, $template_array, array('%s','%s','%s','%s','%s','%s','%s'));

        $file_name_arr[$templates] = $wpdb->insert_id;
    }

       $form_opts = $wpdb->get_results($wpdb->prepare("SELECT id,options FROM `".$MdlDb->forms."` WHERE is_template = %d AND status = %s", 0, 'published'));

    foreach( $form_opts as $k => $form_opt ){

         $form_id = $form_opt->id;
         $options = maybe_unserialize($form_opt->options);

        if(isset($options['arf_pdf_template']) && $options['arf_pdf_template'] != '' ) {
            $pdf_file_name = $options['arf_pdf_template'];

            $template_id = isset($file_name_arr[$pdf_file_name]) ? $file_name_arr[$pdf_file_name] : 1;

            $options['arf_pdf_template'] = $template_id;
        }

         $wpdb->update($MdlDb->forms, array('options' => maybe_serialize($options) ), array('id' => $form_id));

    }

}

    if( version_compare($newarformspdfcreator_version, '2.7', '<') ){
        update_option( 'arf_pdfcreator_font_notice', 'yes' );
    }

    if( version_compare( $newarformspdfcreator_version, '2.9', '<') ){
        global $wpdb,$arformspdfcreator;
        $wpdb->query("ALTER TABLE `".$arformspdfcreator->db_pdf_creator."` CHANGE `template_content` `template_content` LONGTEXT");
    }

    update_option('arformspdfcreator_version', '3.0');
    
    global $newarformspdfcreator_version;

    $newarformspdfcreator_version = '3.0';

?>