"use strict";
var status       = 1;
var cursor_focus = "arf_pdfcreator_editor";

function import_fonts_ajax_call(json_form_data)
{
    jQuery.ajax(
        {
            url: ajaxurl,
            type: "POST",
            data: {
                action: "pdf_import_font",
                data: json_form_data,
            },
            success: function (res) {
                var response = JSON.parse(res);
                if (response.state == 'fail') {
                    jQuery('#arf_modal_overlay_extrafonts').removeClass('arfactive');
                    jQuery('#arf_pdf_extrafonts_popup').removeClass('arfactive');
                    jQuery("#pdf_creator_err_msg").html(response.message);
                    setTimeout(
                        function () {
                             error_msg(); },100
                    );
                } else if (response.state == 'warning') {

                    jQuery("#pdf_creator_warning_msg").html(response.message);
                    setTimeout(
                        function () {
                            warning_msg(); },100
                    );
                } else {
                    jQuery("#pdf_creator_success_msg").html(response.message);
                    setTimeout(
                        function () {
                            success_msg(); },100
                    );
                }

            },

        }
    );
}

function imported_font_progress(total){
    jQuery.ajax({
        url: ajaxurl,
        type: "POST",
        data:{
            action: "pdf_imported_font_progress"
        },
        success: function( res ){
            var obj = jQuery.parseJSON(res);
            var imported = obj.imported_fonts;
            //var total = obj.total_fonts;
            var isRepeat = obj.continue;

            if( isRepeat ){
                imported_font_progress(total);
            }

            var avg = (imported * 100) / total;
            jQuery("#font_progress").css('width', Math.ceil(avg) + '%');
            jQuery("#font_progress").css('color', '#fff');
            avg = Math.ceil(avg) ? Math.ceil(avg) : 0;
            jQuery("#font_progress").html(Math.ceil(avg) + '%');

            if (avg == 100 || total == 0) {
                setTimeout(
                    function () {
                        jQuery("#important_extra_fonts_button").removeAttr('disabled');
                        jQuery("#important_extra_fonts_button").removeAttr('style');
                        jQuery('.font_progress_wraper').css('display', 'none');
                        jQuery('#arf_modal_overlay_extrafonts').removeClass('arfactive');
                        jQuery('#arf_pdf_extrafonts_popup').removeClass('arfactive');
                    },
                    1000
                );
            }
        }
    });
}

jQuery(document).ready(
    function () {
        arf_adjust_right_panel_height();
    }
);

jQuery(window).resize(
    function () {
        arf_adjust_right_panel_height();
    }
);

function arf_adjust_right_panel_height()
{

    if (document.querySelector('.arf_pdf_form_field_viewer') == null || document.querySelector('.arf_pdf_form_field_viewer .arf_accordion_container.active') == null ) {
        return false;
    }

    var tab_container_height = jQuery('.arf_pdf_form_field_viewer').outerHeight();
    var tab_height           = jQuery('.arf_pdfcreator_right_panel_accordion').outerHeight();
    var total_tab            = jQuery('.arf_pdfcreator_right_panel_accordion').length;
    var final_tab_height     = tab_height * total_tab;

    var inner_height = ((tab_container_height - final_tab_height) - 10);

    jQuery('.arf_accordion_container.active').css('min-height',inner_height);
    jQuery('.arf_accordion_container.active').css('max-height',inner_height);

    document.getElementById('arf_pdf_accordion_tab_height').value = inner_height;

}

jQuery(document).on(
    'click',
    '#cancel_editing_template',
    function () {
        reset_page();
    }
);

jQuery(document).on(
    'click',
    '#arf_pdf_delete_template',
    function () {
        jQuery(this).attr('disabled','disabled');
        jQuery(this).css('cursor','not-allowed');
        template_id = jQuery('#pdf_template_selector').val();
        jQuery.ajax(
            {
                url: ajaxurl,
                type: "POST",
                data: {
                    action:"delete_pdf_template",
                    tmpl_id: template_id,
                },
                success: function (res) {
                       jQuery('#arf_pdf_delete_template').removeAttr('disabled');
                       jQuery('#arf_pdf_delete_template').css('cursor','pointer');
                       jQuery('.pdf_template_delete_icon').css('display','none');
                       var obj = JSON.parse(res);
                    if (obj.state == 'success') {
                        reset_page();

                        jQuery('#pdf_template_selector_dropdown').children('dd').children('ul').children('li[data-value="' + template_id + '"]').remove();
                        jQuery("#pdf_creator_success_msg").html(obj.message);
                        setTimeout(
                            function () {
                                success_msg(); },10
                        );
                    } else {
                        jQuery("#pdf_creator_err_msg").html(obj.message);
                        setTimeout(
                            function () {
                                error_msg(); },10
                        );
                    }
                    jQuery('.arf_modal_overlay').removeClass('arfactive');
                    jQuery('.arf_popup_container').removeClass('arfactive');
                },
            }
        );
    }
);

jQuery(document).on(
    'click',
    '#delete_pdf_template',
    function () {
        jQuery('#arf_modal_overlay_template_delete').addClass('arfactive');
        jQuery('#arf_pdf_template_popup_delete').addClass('arfactive');
    }
);

jQuery(document).on(
    'click',
    '#important_extra_fonts_button',
    function () {
        var avg          = 0;
        var progress_bar = "0%";
        jQuery("#font_progress").css('width', progress_bar);

        jQuery("#font_progress").html('');
        jQuery('.font_progress_wraper').css('display', 'block');
        jQuery(this).attr('disabled', 'disabled');
        jQuery(this).attr('style', 'color:#fff; cursor: not-allowed;');

        var form_data    = document.querySelectorAll("#pdf_extra_fonts_form");
        var field_length = form_data.length;
        var objarray     = [];
        for ( var x = 0; x < field_length; x++ ) {
            var obj  = form_data[x];
            var json = obj.serializeJSON();
            objarray.push(json);
        }
        var fields = objarray.reduce(
            function (result, currentObject) {
                for (var key in currentObject) {
                    if (currentObject.hasOwnProperty(key)) {
                        result[key] = currentObject[key];
                    }
                }
                return result;
            },
            {}
        );

        if (fields.arf_pdf_extra_fonts == undefined) {
            jQuery(".arf_pdf_font_list_empty_err").show();
            jQuery('.font_progress_wraper').css('display', 'none');
            jQuery(this).removeAttr('disabled');
            jQuery(this).removeAttr('style');
            return false;
        }

        var json_form_data = jQuery.toJSON(fields);

        import_fonts_ajax_call(json_form_data);

        imported_font_progress(Object.keys(fields.arf_pdf_extra_fonts).length);

        return false;
    }
);

jQuery(document).on(
    'click',
    '#pdfcreator_form_data',
    function () {
        var template_name = jQuery('#pdf_template_selector').val();
        if (template_name == "" || template_name == 0) {
            window.scrollTo(0,0);
            jQuery('.pdf_blank_template_field_err').html(__TEMPLATE_NAME_MSG);
            return false;
        } else {
            jQuery('.pdf_blank_template_field_err').html('');
            var update = jQuery(this).val();
            pdf_ajax_call(update);
            return false;
        }
    }
);

jQuery(document).on(
    'click',
    '#arf_pdf_save_template',
    function () {
        var tmp_name = jQuery('#arf_pdf_template_name').val();
        if (tmp_name == "") {
            jQuery('.arf_pdf_blank_template_err').html("<p>"+__BLANK_TEMPLATE_NAME_MSG+"</p>");
            return false;
        } else {
            jQuery('.arf_pdf_blank_template_err').html("");
            jQuery('.arf_modal_overlay_template').removeClass('arfactive');
            jQuery('.arf_pdf_template_popup').removeClass('arfactive');
            var save = jQuery(this).val();
            pdf_ajax_call(save);

            return false;
        }
    }
);

jQuery(document).on(
    'change',
    '#arf_form_selector',
    function () {
        var formid = jQuery(this).val();
        var loader = '<div class="arf_pdfcreator_content_loader"><div class="arf_imageloader" id="ajax_pdfcreator_content_loader"></div></div>';
        jQuery('.arf_pdf_form_field_accordion dd div.arf_accordion_container').html(loader);
        jQuery.ajax(
            {
                url: ajaxurl,
                type: "POST",
                data: {
                    action:"pdfcreatorgetformfields",
                    data: formid,
                },
                success: function (res) {
                       jQuery('.arf_pdf_form_field_accordion dd div.arf_accordion_container').html("");
                       jQuery('.arf_pdf_form_field_accordion dd div.arf_accordion_container').html(res);
                },
            }
        );
    }
);


jQuery(document).on(
    'change',
    '#pdf_template_selector',
    function () {
        if (jQuery(this).val() > 0) {
            jQuery('.pdf_template_delete_icon').css('display','inline-block');
        } else {
            jQuery('.pdf_template_delete_icon').css('display','none');
        }
        var template_id = jQuery('#pdf_template_selector').val();
        var loader      = '<div class="arf_pdfcreator_editor_content_loader"><div class="arf_imageloader" id="ajax_pdfcreator_content_loader"></div></div>';

        var size, orientation, font;
        if (template_id != 0 && template_id != '') {

            jQuery('textarea#arf_pdfcreator_editor').val("");
            jQuery('.arf_pdf_option_selected_preview_div').append(loader);
            jQuery.ajax(
                {
                    url: ajaxurl,
                    type: "POST",
                    data: {
                        action: "gettemplate",
                        data: template_id,
                    },
                    success: function (res) {
                           var obj = JSON.parse(res);

                           jQuery('textarea#arf_pdfcreator_editor').val(obj.template_content);
                           jQuery('textarea#arf_pdfcreator_editor_header_left').val(obj.template_header_left);
                           jQuery('textarea#arf_pdfcreator_editor_header_center').val(obj.template_header_center);
                           jQuery('textarea#arf_pdfcreator_editor_header_right').val(obj.template_header_right);
                           jQuery('textarea#arf_pdfcreator_editor_footer_left').val(obj.template_footer_left);
                           jQuery('textarea#arf_pdfcreator_editor_footer_center').val(obj.template_footer_center);
                           jQuery('textarea#arf_pdfcreator_editor_footer_right').val(obj.template_footer_right);

                           jQuery('#arf_pdf_template_size').val(obj.template_size);
                           size = jQuery('#arf_pdf_template_size').next('dl').children('dd').children('ul').children('li[data-value="' + obj.template_size + '"]').attr('data-label');
                           jQuery('#arf_pdf_template_size').next('dl').children('dt').children('span').html(size);

                           jQuery('#arf_pdf_template_orientation').val(obj.template_orientation);
                           orientation = jQuery('#arf_pdf_template_orientation').next('dl').children('dd').children('ul').children('li[data-value="' + obj.template_orientation + '"]').attr('data-label');
                           jQuery('#arf_pdf_template_orientation').next('dl').children('dt').children('span').html(orientation);

                           jQuery('#arf_pdf_template_font').val(obj.template_font);
                           font = jQuery('#arf_pdf_template_font').next('dl').children('dd').children('ul').children('li[data-value="' + obj.template_font + '"]').attr('data-label');
                           jQuery('#arf_pdf_template_font').next('dl').children('dt').children('span').html(font);

                        if (obj.pdf_pageno == 1) {
                            jQuery('#pdf_pgno').attr('checked', 'checked');
                            jQuery('#pdf_pgno').val(obj.pdf_pageno);
                        } else {
                            jQuery('#pdf_pgno').removeAttr('checked');
                            jQuery('#pdf_pgno').val(obj.pdf_pageno);
                        }
                        jQuery('.arf_toggle_btn').removeClass('arf_success');
                        jQuery('.visuallyhidden').removeAttr('checked');
                        if (obj.pdf_header_img_align == 'left') {
                            jQuery('#pdf_header_img_align_left').addClass('arf_success');
                            jQuery('#pdf_header_img_align_left input').attr('checked','checked');
                        } else if (obj.pdf_header_img_align == 'right') {
                            jQuery('#pdf_header_img_align_right').addClass('arf_success');
                            jQuery('#pdf_header_img_align_right input').attr('checked','checked');
                        } else {
                            jQuery('#pdf_header_img_align_center').addClass('arf_success');
                            jQuery('#pdf_header_img_align_center input').attr('checked','checked');
                        }

                        var del_icon = '<svg width="23px" height="27px" viewBox="0 0 30 30"><path xmlns="http://www.w3.org/2000/svg" fill-rule="evenodd" clip-rule="evenodd" fill="#4786FF" d="M19.002,4.351l0.007,16.986L3.997,21.348L3.992,4.351H1.016V2.38  h1.858h4.131V0.357h8.986V2.38h4.146h1.859l0,0v1.971H19.002z M16.268,4.351H6.745H5.993l0.006,15.003h10.997L17,4.351H16.268z   M12.01,7.346h1.988v9.999H12.01V7.346z M9.013,7.346h1.989v9.999H9.013V7.346z"></path></svg>';
                        if (obj.pdf_header_img_name != '' ) {
                            var img = '<img src="' + obj.pdf_header_img_path + '" /><div class="img_remove_div" onclick="remove_img_preview(this);">' + del_icon + '</div>';
                            jQuery('.pdf_header_img_preview').empty();
                            jQuery('.pdf_header_img_preview').html(img);
                            jQuery('#pdf_header_img_name').val(obj.pdf_header_img_name);
                            jQuery('.pdf_header_img_preview').css('display','block');
                        } else {
                            jQuery('.pdf_header_img_preview').empty();
                        }
                        jQuery('.arf_pdfcreator_editor_content_loader').remove();
                    },
                }
            );
        }
    }
);

jQuery(document).on(
    'click',
    '.arf_pdf_form_field_accordion',
    function () {

        jQuery('.arf_pdf_extrafield_accordion').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion').removeClass('active');
        jQuery('.arf_pdf_extrafield_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion dd div').removeClass('active');

        jQuery('.arf_accordion_container').css('min-height','');
        jQuery('.arf_accordion_container').css('max-height','');

        jQuery('.arf_pdf_form_field_accordion').addClass('active');
        jQuery('.arf_pdf_form_field_accordion dd div').addClass('active');

        arf_adjust_right_panel_height();
    }
);

jQuery(document).on(
    'click',
    '.arf_pdf_extrafield_accordion',
    function () {
        jQuery('.arf_pdf_form_field_accordion').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion').removeClass('active');
        jQuery('.arf_pdf_form_field_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion dd div').removeClass('active');

        jQuery('.arf_accordion_container').css('min-height','');
        jQuery('.arf_accordion_container').css('max-height','');

        jQuery('.arf_pdf_extrafield_accordion').addClass('active');
        jQuery('.arf_pdf_extrafield_accordion dd div').addClass('active');

        arf_adjust_right_panel_height();
    }
);

jQuery(document).on(
    'click',
    '.arf_pdf_shortcode_accordion',
    function () {
        jQuery('.arf_pdf_form_field_accordion').removeClass('active');
        jQuery('.arf_pdf_extrafield_accordion').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion').removeClass('active');
        jQuery('.arf_pdf_form_field_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_extrafield_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion dd div').removeClass('active');

        jQuery('.arf_accordion_container').css('min-height','');
        jQuery('.arf_accordion_container').css('max-height','');

        jQuery('.arf_pdf_shortcode_accordion').addClass('active');
        jQuery('.arf_pdf_shortcode_accordion dd div').addClass('active');

        arf_adjust_right_panel_height();
    }
);

jQuery(document).on(
    'click',
    '.arf_pdf_other_option_accordion',
    function () {
        jQuery('.arf_pdf_form_field_accordion').removeClass('active');
        jQuery('.arf_pdf_extrafield_accordion').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion').removeClass('active');
        jQuery('.arf_pdf_form_field_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_extrafield_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_userdetail_accordion dd div').removeClass('active');

        jQuery('.arf_accordion_container').css('min-height','');
        jQuery('.arf_accordion_container').css('max-height','');

        jQuery('.arf_pdf_other_option_accordion').addClass('active');
        jQuery('.arf_pdf_other_option_accordion dd div').addClass('active');

        arf_adjust_right_panel_height();
    }
);

jQuery(document).on(
    'click',
    '.arf_pdf_userdetail_accordion',
    function () {
        jQuery('.arf_pdf_form_field_accordion').removeClass('active');
        jQuery('.arf_pdf_extrafield_accordion').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion').removeClass('active');
        jQuery('.arf_pdf_form_field_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_extrafield_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_shortcode_accordion dd div').removeClass('active');
        jQuery('.arf_pdf_other_option_accordion dd div').removeClass('active');

        jQuery('.arf_accordion_container').css('min-height','');
        jQuery('.arf_accordion_container').css('max-height','');

        jQuery('.arf_pdf_userdetail_accordion').addClass('active');
        jQuery('.arf_pdf_userdetail_accordion dd div').addClass('active');

        arf_adjust_right_panel_height();
    }
);

jQuery(document).on(
    'click',
    '.arf_pdf_saveas_label',
    function () {
        jQuery('#arf_modal_overlay_template').addClass('arfactive');
        jQuery('#arf_pdf_template_popup').addClass('arfactive');
    }
);

jQuery(document).on(
    'click',
    '.arf_pdf_import_fonts_link',
    function (event) {
        jQuery(".arf_pdf_font_list_empty_err").hide();
        jQuery('#arf_modal_overlay_extrafonts').addClass('arfactive');
        jQuery('#arf_pdf_extrafonts_popup').addClass('arfactive');
    }
);



jQuery(document).on(
    'click',
    '#arf_pdf_close_modal',
    function () {
        jQuery('.arf_modal_overlay').removeClass('arfactive');
        jQuery('.arf_popup_container').removeClass('arfactive');
    }
);

jQuery(document).on(
    'click',
    '#arf_pdf_close_delete_modal',
    function () {
        jQuery('.arf_modal_overlay').removeClass('arfactive');
        jQuery('.arf_popup_container').removeClass('arfactive');
    }
);

jQuery(document).on(
    'focusin',
    'textarea',
    function (e) {
        cursor_focus = e.target.id;
    }
);

jQuery(document).on(
    "change",
    '#pdf_header_img',
    function () {
        var loader = '<div class="arf_pdfcreator_content_loader arf_pdf_upload_logo_loader"><div class="arf_imageloader" id="ajax_pdfcreator_content_loader"></div></div>';
        jQuery('.pdf_header_img_preview').html(loader);
        var formdata   = new FormData();
        var uploadFile = jQuery("#pdf_header_img").prop('files')[0];
        formdata.append('img_file', uploadFile);
        formdata.append('action', 'pdf_img_upload');
        jQuery.ajax(
            {
                url: ajaxurl,
                type: "POST",
                data: formdata,
                processData: false,
                contentType: false,
                success: function (res) {
                       var obj = JSON.parse(res);
                       jQuery('.pdf_header_img_preview').children('.arf_pdfcreator_content_loader').remove();

                    if (obj.state == 'success') {
                        jQuery(".pdf_header_img_err_msg").html("");
                        jQuery("#pdf_header_img_name").val(obj.response)
                        jQuery('.pdf_header_img_preview').css('display','block');
                        var del_icon = '<svg width="23px" height="27px" viewBox="0 0 30 30"><path xmlns="http://www.w3.org/2000/svg" fill-rule="evenodd" clip-rule="evenodd" fill="#4786FF" d="M19.002,4.351l0.007,16.986L3.997,21.348L3.992,4.351H1.016V2.38  h1.858h4.131V0.357h8.986V2.38h4.146h1.859l0,0v1.971H19.002z M16.268,4.351H6.745H5.993l0.006,15.003h10.997L17,4.351H16.268z   M12.01,7.346h1.988v9.999H12.01V7.346z M9.013,7.346h1.989v9.999H9.013V7.346z"></path></svg>';
                        var img      = '<img src="' + obj.img_path + '" /><div class="img_remove_div" onclick="remove_img_preview(this);">' + del_icon + '</div>';
                        jQuery('.pdf_header_img_preview').empty();
                        jQuery('.pdf_header_img_preview').html(img);
                    }

                    if (obj.state == 'invalid file') {
                        jQuery(".pdf_header_img_err_msg").html(obj.response);
                    }
                    if (obj.state == 'fail') {
                        jQuery(".pdf_header_img_err_msg").html(obj.response);
                    }
                    if (obj.state == 'error') {
                        jQuery(".pdf_header_img_err_msg").html(obj.response);
                    }
                }
            }
        );
    }
);


function reset_page()
{
    jQuery('#arf_pdfcreator_form_data').trigger("reset");
    jQuery('#arf_form_selector_dropdown').children('dt').children('span').html("Select Form");
    jQuery('#arf_form_selector').val(0);
    jQuery('#pdf_template_selector_dropdown').children('dt').children('span').html("Select Template");
    jQuery('#pdf_template_selector').val(0);
    jQuery('#pdf_template_size_dropdown').children('dt').children('span').html("A4 (210 x 297mm)");
    jQuery('#arf_pdf_template_size').val("A4");
    jQuery('#arf_pdf_orientation_dropdown').children('dt').children('span').html("Portrait");
    jQuery('#arf_pdf_template_orientation').val("portrait");
    jQuery('#pdf_template_font_dropdown').children('dt').children('span').html("Arial");
    jQuery('#arf_pdf_template_font').val("arf_arial");

    jQuery('#pdf_header_img_name').val("");
    jQuery('.pdf_header_img_preview').html("");
    jQuery('.pdf_header_img_preview').css("display","none");

    jQuery('#pdf_header_img_align_left').removeClass("arf_success");
    jQuery('#pdf_header_img_align_center').removeClass("arf_success");
    jQuery('#pdf_header_img_align_right').removeClass("arf_success");
    jQuery('#pdf_header_img_align_center').addClass("arf_success");

    jQuery('#pdf_header_img_align_left').children().removeAttr('checked','checked');
    jQuery('#pdf_header_img_align_center').children().removeAttr('checked','checked');
    jQuery('#pdf_header_img_align_right').children().removeAttr('checked','checked');
    jQuery('#pdf_header_img_align_center').children().attr('checked','checked');

    jQuery('.arf_pdf_form_field_accordion').children('dd').children('div.arf_accordion_container').empty();

    jQuery('#delete_pdf_template').css('display','none');

}


function remove_img_preview(obj)
{
    jQuery(obj).parent(".pdf_header_img_preview").empty();
    jQuery("#pdf_header_img_name").val("");
}


function pdf_ajax_call(state)
{

    jQuery('#arf_full_width_loader').css('display', 'block');

    var form_data    = document.querySelectorAll("#arf_pdfcreator_form_data");
    var field_length = form_data.length;
    var objarray     = [];
    for ( var x = 0; x < field_length; x++ ) {
        var obj  = form_data[x];
        var json = obj.serializeJSON();
        objarray.push(json);
    }
    var fields = objarray.reduce(
        function (result, currentObject) {
            for (var key in currentObject) {
                if (currentObject.hasOwnProperty(key)) {
                    result[key] = currentObject[key];
                }
            }
            return result;
        },
        {}
    );

    fields['state'] = state;
    var json_form_data  = jQuery.toJSON(fields);

    jQuery.ajax(
        {
            url: ajaxurl,
            type: "POST",
            data: {
                action: 'pdfcreator_save_data',
                data: json_form_data,
            },
            success: function (res) {
                jQuery('#arf_full_width_loader').css('display', 'none');

                var obj = JSON.parse(res);

                if (obj.state == "error") {
                    jQuery("#pdf_creator_err_msg").html(obj.message);
                    setTimeout(
                        function () {
                             error_msg(); },10
                    );
                }
                if (obj.state == "save") {

                    jQuery('.arf_modal_overlay').removeClass('arfactive');
                    jQuery('.arf_pdf_template_popup').removeClass('arfactive');
                    success_response(obj);
                    jQuery('.pdf_template_delete_icon').css('display','inline-block');
                    jQuery("#pdf_creator_success_msg").html(obj.message);
                    setTimeout(
                        function () {
                            success_msg(); },10
                    );

                }
                if (obj.state == "update") {
                    success_response(obj);
                    jQuery("#pdf_creator_success_msg").html(obj.message);
                    setTimeout(
                        function () {
                            success_msg(); },10
                    );
                }

            }
        }
    );
}

function success_response(obj)
{

    if (obj.state == "save") {
        jQuery('dl[data-id="pdf_template_selector"]').children('dt').children('span').html(obj.template_name);
        var li_content = '<li class="arf_selectbox_option" data-value="' + obj.id + '" data-label="' + obj.template_name + '">' + obj.template_name + '</li>';
        jQuery('dl[data-id="pdf_template_selector"]').children('dd').children('ul').append(li_content);
    }

    jQuery('#pdf_template_selector').val(obj.id);

    jQuery('textarea#arf_pdfcreator_editor').val(obj.template_content);
    jQuery('textarea#arf_pdfcreator_editor_header_left').val(obj.template_header_left);
    jQuery('textarea#arf_pdfcreator_editor_header_center').val(obj.template_header_center);
    jQuery('textarea#arf_pdfcreator_editor_header_right').val(obj.template_header_right);
    jQuery('textarea#arf_pdfcreator_editor_footer_left').val(obj.template_footer_left);
    jQuery('textarea#arf_pdfcreator_editor_footer_center').val(obj.template_footer_center);
    jQuery('textarea#arf_pdfcreator_editor_footer_right').val(obj.template_footer_right);

    jQuery('#arf_pdf_template_size').val(obj.size);
    var size = jQuery('#arf_pdf_template_size').next('dl').children('dd').children('ul').children('li[data-value="' + obj.size + '"]').attr('data-label');
    jQuery('#arf_pdf_template_size').next('dl').children('dt').children('span').html(size);

    jQuery('#arf_pdf_template_orientation').val(obj.orientation);
    var orientation = jQuery('#arf_pdf_template_orientation').next('dl').children('dd').children('ul').children('li[data-value="' + obj.orientation + '"]').attr('data-label');
    jQuery('#arf_pdf_template_orientation').next('dl').children('dt').children('span').html(orientation);

    jQuery('#arf_pdf_template_font').val(obj.font);
    var font = jQuery('#arf_pdf_template_font').next('dl').children('dd').children('ul').children('li[data-value="' + obj.font + '"]').attr('data-label');
    jQuery('#arf_pdf_template_font').next('dl').children('dt').children('span').html(font);
}

function arfaddcodefornewfield(variable, element, option)
{
    var element = (typeof element !== 'undefined') ? element : cursor_focus;
    var option  = (typeof option !== 'undefined') ? option : '';

    var element_id = element;
    var variable2  = '';

    if (variable == 'LOOP' || variable == 'IF' || variable == 'Signature') {
        if (variable == 'Signature') {
            variable2 = '{ARF_' + variable + '}\n /*Your code goes here*/ \n{/ARF_' + variable + '}';
        } else {
            variable2 = '[ARF_' + variable + ']\n /*Your code goes here*/ \n[/ARF_' + variable + ']';
        }
    } else {
        if (option == '') {
            variable2 = '{ARF_' + variable + '}';
        } else {
            variable2 = '{ARF_GetLabel:' + variable + '}:{ARF_GetValue:' + variable + '}';
        }
    }

    insertAtCaret(element_id, variable2);

    return;
}


function add_field_to_editor(obj)
{
    var id = jQuery(obj).attr('data-value');
    arfaddcodefornewfield(id, cursor_focus, id);
}


function open_pdf_field_option_dropdown(obj)
{

    if (status == 1) {
        jQuery(obj).children('.arf_pdf_form_fields_container').css('display','block');
        status = 0;
    } else {
        jQuery(obj).children('.arf_pdf_form_fields_container').css('display','none');
        status = 1;
    }
}

jQuery(document).mouseup(
    function (e) {
        var container = jQuery(".dropdown-content");

        if (! container.is(e.target) && container.has(e.target).length === 0) {
            jQuery('.arf_pdf_form_fields').children('.arf_pdf_form_fields_container').css('display','none');
            status = 1;
        }

    }
);
function warning_msg()
{

    jQuery('#pdf_warning_message').delay(1000).animate(
        {
            width: 'toggle',
        },
        'slow'
    );
    setTimeout(
        function () {
            jQuery('#pdf_warning_message').animate(
                {
                    width: 'toggle',
                },
                'slow'
            );
        },
        4000
    );
}